Attribute VB_Name = "modBrowse"
Option Explicit

''BROWSEINFO.ulFlags values - copied from http://vbnet.mvps.org/index.html?code/browse/browseadv.htm
Private Const BIF_RETURNONLYFSDIRS   As Long = &H1 'only file system directories
Private Const BIF_DONTGOBELOWDOMAIN As Long = &H2  'no network folders below domain level
Private Const BIF_STATUSTEXT As Long = &H4         'include status area for callback
Private Const BIF_RETURNFSANCESTORS As Long = &H8  'only return file system ancestors
Private Const BIF_EDITBOX As Long = &H10           'add edit box
Private Const BIF_NEWDIALOGSTYLE As Long = &H40    'use the new dialog layout
Private Const BIF_UAHINT As Long = &H100
Private Const BIF_NONEWFOLDERBUTTON As Long = &H200 'hide new folder button
Private Const BIF_NOTRANSLATETARGETS As Long = &H400 'return lnk file
Private Const BIF_USENEWUI As Long = BIF_NEWDIALOGSTYLE Or BIF_EDITBOX
Private Const BIF_BROWSEFORCOMPUTER As Long = &H1000 'only return computers
Private Const BIF_BROWSEFORPRINTER As Long = &H2000 'only return printers
Private Const BIF_BROWSEINCLUDEFILES As Long = &H4000 'browse for everything
Private Const BIF_SHAREABLE As Long = &H8000 'sharable resources, requires BIF_USENEWUI

Public Type BROWSEINFO
    hwndOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type

Private Declare Function SHBrowseForFolder Lib "shell32.dll" _
   Alias "SHBrowseForFolderA" _
  (lpBrowseInfo As BROWSEINFO) As Long

Declare Function SHGetPathFromIDList Lib "shell32.dll" _
   Alias "SHGetPathFromIDListA" (ByVal pidl As Long, _
  ByVal pszPath As String) As Long

Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)

Public Sub browse()
'    On Error GoTo oops
    Dim cR As New cRegistry
    Dim bi As BROWSEINFO  ' structure passed to the function
    Dim pidl As Long  ' PIDL to the user's selection
    Dim physpath As String  ' string used to temporarily hold the physical path
    Dim RetVal As Long  ' return value
    Dim strTemppath As String 'temp store the current GTA2 path
    ' Initialize the structure to be passed to the function.
    strTemppath = strGTA2path
    With bi
        ' The owner of the dialog box.
        .hwndOwner = frmLauncher.hWnd
        ' Specify the My Computer virtual folder as the root.
        'RetVal = SHGetSpecialFolderLocation(frmLauncher.hWnd, CSIDL_DRIVES, .pidlRoot)
        ' Make room in the buffer to get the [virtual] folder's display name.
        .pszDisplayName = Space(260)
        ' Message displayed to the user.
        .lpszTitle = "Where is your GTA2 folder?"
        .ulFlags = BIF_USENEWUI + BIF_NONEWFOLDERBUTTON + BIF_RETURNONLYFSDIRS
        .lpfn = 0
        .lParam = 0
        .iImage = 0
    End With

    ' Open the Browse for Folder dialog box.
    pidl = SHBrowseForFolder(bi)
    'Call SendMessage(frmLauncher.hWnd, BFFM_ENABLEOK, 0, 0)
    'Set objFolder = objShell.BrowseForFolder(0, "Example", 0, ssfWINDOWS)
    ' If the user selected something, display its display name
    ' and its physical location on the system.
    If pidl <> 0 Then
        ' Remove the empty space from the display name variable.
        bi.pszDisplayName = Left(bi.pszDisplayName, InStr(bi.pszDisplayName, vbNullChar) - 1)
        'Debug.Print "The user selected: "; bi.pszDisplayName
        ' If the folder is not a virtual folder, display its physical location.
        physpath = Space(260)
        RetVal = SHGetPathFromIDList(pidl, physpath)
        If RetVal = 0 Then
            'Debug.Print "Physical Location: (virtual folder)"
        Else
            ' Remove the empty space and display the result.
            physpath = Left(physpath, InStr(physpath, vbNullChar) - 1)
            If Right(physpath, 1) <> "\" Then physpath = physpath & "\"
            'Debug.Print "Physical Location: "; physpath
            strGTA2path = physpath
        End If
        ' Free the pidl returned by the function.
        CoTaskMemFree pidl
    End If

    ' Whether successful or not, free the PIDL which was used to
    ' identify the My Computer virtual folder.

    CoTaskMemFree bi.pidlRoot

    If pidl <> 0 Then 'if the OK button is pushed
        If RetVal <> 0 And exists(physpath & "GTA2.exe") = True And _
            exists(physpath & "data\attract\attr1.rep") = True Then
            strGTA2path = physpath
            With cR
                .ClassKey = HKEY_CURRENT_USER
                .SectionKey = "SOFTWARE\GTA2 Game Hunter"
                .ValueKey = "GTA2Folder"
                .ValueType = REG_SZ
                .Value = strGTA2path
            End With
        Else
            strGTA2path = strTemppath
            browse
        End If
    Else
        Exit Sub
    End If

    Exit Sub

oops:
    strErrdesc = Err.Description
    MsgBox strErrdesc
End Sub
